package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;

public class CRLDistPoint extends ASN1Encodable {
   ASN1Sequence seq = null;

   public static CRLDistPoint getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(ASN1Sequence.getInstance(obj, explicit));
   }

   public static CRLDistPoint getInstance(Object obj) {
      if (!(obj instanceof CRLDistPoint) && obj != null) {
         if (obj instanceof ASN1Sequence) {
            return new CRLDistPoint((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("unknown object in factory: " + obj.getClass().getName());
         }
      } else {
         return (CRLDistPoint)obj;
      }
   }

   public CRLDistPoint(ASN1Sequence seq) {
      this.seq = seq;
   }

   public CRLDistPoint(DistributionPoint[] points) {
      ASN1EncodableVector var2;
      var2 = new ASN1EncodableVector.<init>();

      for(int var3 = 0; var3 != points.length; ++var3) {
         var2.add(points[var3]);
      }

      DERSequence var4;
      var4 = new DERSequence.<init>(var2);
      this.seq = var4;
   }

   public DistributionPoint[] getDistributionPoints() {
      DistributionPoint[] var1 = new DistributionPoint[this.seq.size()];

      for(int var2 = 0; var2 != this.seq.size(); ++var2) {
         var1[var2] = DistributionPoint.getInstance(this.seq.getObjectAt(var2));
      }

      return var1;
   }

   public DERObject toASN1Object() {
      return this.seq;
   }

   public String toString() {
      StringBuffer var4;
      StringBuffer var10001 = var4 = new StringBuffer;
      var10001.<init>();
      String var1 = System.getProperty("line.separator");
      var10001.append("CRLDistPoint:");
      var10001.append(var1);
      DistributionPoint[] var2 = this.getDistributionPoints();

      for(int var3 = 0; var3 != var2.length; ++var3) {
         var4.append("    ");
         var4.append(var2[var3]);
         var4.append(var1);
      }

      return var4.toString();
   }
}
